searchData={"items":[{"type":"module","title":"Gremlex","doc":"","ref":"Gremlex.html"},{"type":"module","title":"Gremlex.Client","doc":"A Mint-based WebSocket client for Gremlin Server.\n\nThis module is a GenServer that connects to a Gremlin Server using the WebSocket protocol.\nIt sends queries to the server and receives responses. It also handles pings and pongs to keep the connection alive.","ref":"Gremlex.Client.html"},{"type":"module","title":"Example - Gremlex.Client","doc":"```\niex> Gremlex.Client.start_link({host: \"localhost\", port: 8182, path: \"/gremlin\", secure: false})\n{:ok, #PID<0.123.0>}\niex> Gremlex.Client.query(%Gremlex.Graph{vertices: [%Gremlex.Vertex{id: \"1\", label: \"person\"}]})\n{:ok, [%Gremlex.Vertex{id: \"1\", label: \"person\"}]}\n```","ref":"Gremlex.Client.html#module-example"},{"type":"function","title":"Gremlex.Client.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Gremlex.Client.html#child_spec/1"},{"type":"type","title":"Gremlex.Client.error_code/0","doc":"","ref":"Gremlex.Client.html#t:error_code/0"},{"type":"function","title":"Gremlex.Client.query/2","doc":"Accepts a graph which it converts into a query and queries the database.\n\nParams:\n* query - A `Gremlex.Graph.t` or raw String query\n* timeout (Default: 30000ms) - Timeout in milliseconds to pass to GenServer and Task.await call","ref":"Gremlex.Client.html#query/2"},{"type":"type","title":"Gremlex.Client.response/0","doc":"","ref":"Gremlex.Client.html#t:response/0"},{"type":"function","title":"Gremlex.Client.start_link/1","doc":"","ref":"Gremlex.Client.html#start_link/1"},{"type":"module","title":"Gremlex.Deserializer","doc":"Deserializer module for deserializing data returned back from Gremlin.","ref":"Gremlex.Deserializer.html"},{"type":"function","title":"Gremlex.Deserializer.deserialize/1","doc":"","ref":"Gremlex.Deserializer.html#deserialize/1"},{"type":"function","title":"Gremlex.Deserializer.deserialize/2","doc":"","ref":"Gremlex.Deserializer.html#deserialize/2"},{"type":"module","title":"Gremlex.Edge","doc":"","ref":"Gremlex.Edge.html"},{"type":"function","title":"Gremlex.Edge.from_response/1","doc":"","ref":"Gremlex.Edge.html#from_response/1"},{"type":"function","title":"Gremlex.Edge.new/7","doc":"","ref":"Gremlex.Edge.html#new/7"},{"type":"type","title":"Gremlex.Edge.t/0","doc":"","ref":"Gremlex.Edge.html#t:t/0"},{"type":"module","title":"Gremlex.Graph","doc":"Functions for traversing and mutating the Graph.\n\nGraph operations are stored in a queue which can be created with `g/0`.\nMosts functions return the queue so that they can be chained together\nsimilar to how Gremlin queries work.\n\nExample:\n```\ng.V(1).values(\"name\")\n```\nWould translate to\n```\ng |> v(1) |> values(\"name\")\n```\n\nNote: This module doesn't actually execute any queries, it just allows you to build one.\nFor query execution see `Gremlex.Client.query/1`","ref":"Gremlex.Graph.html"},{"type":"function","title":"Gremlex.Graph.add_e/2","doc":"Appends an addE command to the traversal.\nReturns a graph to allow chaining.","ref":"Gremlex.Graph.html#add_e/2"},{"type":"function","title":"Gremlex.Graph.add_namespace/1","doc":"Adds a namespace as property","ref":"Gremlex.Graph.html#add_namespace/1"},{"type":"function","title":"Gremlex.Graph.add_namespace/2","doc":"","ref":"Gremlex.Graph.html#add_namespace/2"},{"type":"function","title":"Gremlex.Graph.add_v/2","doc":"Appends an addV command to the traversal.\nReturns a graph to allow chaining.","ref":"Gremlex.Graph.html#add_v/2"},{"type":"function","title":"Gremlex.Graph.aggregate/2","doc":"Appends an aggregate command to the traversal.\nReturns a graph to allow chaining.","ref":"Gremlex.Graph.html#aggregate/2"},{"type":"function","title":"Gremlex.Graph.and_/1","doc":"","ref":"Gremlex.Graph.html#and_/1"},{"type":"function","title":"Gremlex.Graph.anonymous/0","doc":"","ref":"Gremlex.Graph.html#anonymous/0"},{"type":"function","title":"Gremlex.Graph.as/2","doc":"","ref":"Gremlex.Graph.html#as/2"},{"type":"function","title":"Gremlex.Graph.barrier/1","doc":"","ref":"Gremlex.Graph.html#barrier/1"},{"type":"function","title":"Gremlex.Graph.barrier/2","doc":"","ref":"Gremlex.Graph.html#barrier/2"},{"type":"function","title":"Gremlex.Graph.both/1","doc":"","ref":"Gremlex.Graph.html#both/1"},{"type":"function","title":"Gremlex.Graph.both/2","doc":"","ref":"Gremlex.Graph.html#both/2"},{"type":"function","title":"Gremlex.Graph.both_e/1","doc":"","ref":"Gremlex.Graph.html#both_e/1"},{"type":"function","title":"Gremlex.Graph.both_e/2","doc":"","ref":"Gremlex.Graph.html#both_e/2"},{"type":"function","title":"Gremlex.Graph.both_v/1","doc":"","ref":"Gremlex.Graph.html#both_v/1"},{"type":"function","title":"Gremlex.Graph.both_v/2","doc":"","ref":"Gremlex.Graph.html#both_v/2"},{"type":"function","title":"Gremlex.Graph.by/1","doc":"","ref":"Gremlex.Graph.html#by/1"},{"type":"function","title":"Gremlex.Graph.by/2","doc":"","ref":"Gremlex.Graph.html#by/2"},{"type":"function","title":"Gremlex.Graph.by/3","doc":"","ref":"Gremlex.Graph.html#by/3"},{"type":"function","title":"Gremlex.Graph.cap/2","doc":"","ref":"Gremlex.Graph.html#cap/2"},{"type":"function","title":"Gremlex.Graph.choose/3","doc":"","ref":"Gremlex.Graph.html#choose/3"},{"type":"function","title":"Gremlex.Graph.coalesce/2","doc":"","ref":"Gremlex.Graph.html#coalesce/2"},{"type":"function","title":"Gremlex.Graph.coin/2","doc":"Appends a coin command to the traversal. Takes in a graph and a probability\nmodifier as parameters.\nReturns a graph to allow chaining.","ref":"Gremlex.Graph.html#coin/2"},{"type":"function","title":"Gremlex.Graph.constant/2","doc":"","ref":"Gremlex.Graph.html#constant/2"},{"type":"function","title":"Gremlex.Graph.count/1","doc":"","ref":"Gremlex.Graph.html#count/1"},{"type":"function","title":"Gremlex.Graph.count/2","doc":"","ref":"Gremlex.Graph.html#count/2"},{"type":"function","title":"Gremlex.Graph.cyclic_path/1","doc":"","ref":"Gremlex.Graph.html#cyclic_path/1"},{"type":"function","title":"Gremlex.Graph.datetime/2","doc":"","ref":"Gremlex.Graph.html#datetime/2"},{"type":"function","title":"Gremlex.Graph.dedup/1","doc":"","ref":"Gremlex.Graph.html#dedup/1"},{"type":"function","title":"Gremlex.Graph.drop/1","doc":"","ref":"Gremlex.Graph.html#drop/1"},{"type":"function","title":"Gremlex.Graph.e/1","doc":"Appends values the `E` command allowing you to select an edge.\nReturns a graph to allow chaining.","ref":"Gremlex.Graph.html#e/1"},{"type":"function","title":"Gremlex.Graph.e/2","doc":"","ref":"Gremlex.Graph.html#e/2"},{"type":"function","title":"Gremlex.Graph.emit/1","doc":"","ref":"Gremlex.Graph.html#emit/1"},{"type":"function","title":"Gremlex.Graph.emit/2","doc":"","ref":"Gremlex.Graph.html#emit/2"},{"type":"function","title":"Gremlex.Graph.encode/1","doc":"Compiles a graph into the Gremlin query.","ref":"Gremlex.Graph.html#encode/1"},{"type":"function","title":"Gremlex.Graph.eq/2","doc":"","ref":"Gremlex.Graph.html#eq/2"},{"type":"function","title":"Gremlex.Graph.fold/1","doc":"","ref":"Gremlex.Graph.html#fold/1"},{"type":"function","title":"Gremlex.Graph.fold/2","doc":"","ref":"Gremlex.Graph.html#fold/2"},{"type":"function","title":"Gremlex.Graph.from/2","doc":"","ref":"Gremlex.Graph.html#from/2"},{"type":"function","title":"Gremlex.Graph.g/0","doc":"Start of graph traversal. All graph operations are stored in a queue.","ref":"Gremlex.Graph.html#g/0"},{"type":"function","title":"Gremlex.Graph.group/1","doc":"","ref":"Gremlex.Graph.html#group/1"},{"type":"function","title":"Gremlex.Graph.group_count/1","doc":"","ref":"Gremlex.Graph.html#group_count/1"},{"type":"function","title":"Gremlex.Graph.group_count/2","doc":"Appends groupCount command to the traversal. Takes in a graph and the name\nof the key that will hold the aggregated grouping.\nReturns a graph to allow chainig.","ref":"Gremlex.Graph.html#group_count/2"},{"type":"function","title":"Gremlex.Graph.gt/2","doc":"","ref":"Gremlex.Graph.html#gt/2"},{"type":"function","title":"Gremlex.Graph.gte/2","doc":"","ref":"Gremlex.Graph.html#gte/2"},{"type":"function","title":"Gremlex.Graph.has/2","doc":"","ref":"Gremlex.Graph.html#has/2"},{"type":"function","title":"Gremlex.Graph.has/3","doc":"","ref":"Gremlex.Graph.html#has/3"},{"type":"function","title":"Gremlex.Graph.has_id/2","doc":"","ref":"Gremlex.Graph.html#has_id/2"},{"type":"function","title":"Gremlex.Graph.has_key/2","doc":"","ref":"Gremlex.Graph.html#has_key/2"},{"type":"function","title":"Gremlex.Graph.has_label/2","doc":"","ref":"Gremlex.Graph.html#has_label/2"},{"type":"function","title":"Gremlex.Graph.has_namespace/1","doc":"","ref":"Gremlex.Graph.html#has_namespace/1"},{"type":"function","title":"Gremlex.Graph.has_namespace/2","doc":"","ref":"Gremlex.Graph.html#has_namespace/2"},{"type":"function","title":"Gremlex.Graph.has_next/1","doc":"","ref":"Gremlex.Graph.html#has_next/1"},{"type":"function","title":"Gremlex.Graph.has_not/2","doc":"","ref":"Gremlex.Graph.html#has_not/2"},{"type":"function","title":"Gremlex.Graph.id/1","doc":"","ref":"Gremlex.Graph.html#id/1"},{"type":"function","title":"Gremlex.Graph.identity/1","doc":"","ref":"Gremlex.Graph.html#identity/1"},{"type":"function","title":"Gremlex.Graph.in_/1","doc":"","ref":"Gremlex.Graph.html#in_/1"},{"type":"function","title":"Gremlex.Graph.in_/2","doc":"","ref":"Gremlex.Graph.html#in_/2"},{"type":"function","title":"Gremlex.Graph.in_e/1","doc":"","ref":"Gremlex.Graph.html#in_e/1"},{"type":"function","title":"Gremlex.Graph.in_e/2","doc":"","ref":"Gremlex.Graph.html#in_e/2"},{"type":"function","title":"Gremlex.Graph.in_v/1","doc":"","ref":"Gremlex.Graph.html#in_v/1"},{"type":"function","title":"Gremlex.Graph.in_v/2","doc":"","ref":"Gremlex.Graph.html#in_v/2"},{"type":"function","title":"Gremlex.Graph.inject/2","doc":"","ref":"Gremlex.Graph.html#inject/2"},{"type":"function","title":"Gremlex.Graph.is/2","doc":"","ref":"Gremlex.Graph.html#is/2"},{"type":"function","title":"Gremlex.Graph.iterate/1","doc":"","ref":"Gremlex.Graph.html#iterate/1"},{"type":"function","title":"Gremlex.Graph.key/1","doc":"","ref":"Gremlex.Graph.html#key/1"},{"type":"function","title":"Gremlex.Graph.label/1","doc":"","ref":"Gremlex.Graph.html#label/1"},{"type":"function","title":"Gremlex.Graph.limit/2","doc":"","ref":"Gremlex.Graph.html#limit/2"},{"type":"function","title":"Gremlex.Graph.limit/3","doc":"","ref":"Gremlex.Graph.html#limit/3"},{"type":"function","title":"Gremlex.Graph.local/2","doc":"","ref":"Gremlex.Graph.html#local/2"},{"type":"function","title":"Gremlex.Graph.loops/1","doc":"","ref":"Gremlex.Graph.html#loops/1"},{"type":"function","title":"Gremlex.Graph.lt/2","doc":"","ref":"Gremlex.Graph.html#lt/2"},{"type":"function","title":"Gremlex.Graph.max/1","doc":"","ref":"Gremlex.Graph.html#max/1"},{"type":"function","title":"Gremlex.Graph.min/1","doc":"","ref":"Gremlex.Graph.html#min/1"},{"type":"function","title":"Gremlex.Graph.neq/2","doc":"","ref":"Gremlex.Graph.html#neq/2"},{"type":"function","title":"Gremlex.Graph.next/1","doc":"","ref":"Gremlex.Graph.html#next/1"},{"type":"function","title":"Gremlex.Graph.next/2","doc":"","ref":"Gremlex.Graph.html#next/2"},{"type":"function","title":"Gremlex.Graph.not_/2","doc":"","ref":"Gremlex.Graph.html#not_/2"},{"type":"function","title":"Gremlex.Graph.or_/1","doc":"","ref":"Gremlex.Graph.html#or_/1"},{"type":"function","title":"Gremlex.Graph.order/1","doc":"","ref":"Gremlex.Graph.html#order/1"},{"type":"function","title":"Gremlex.Graph.other_v/1","doc":"","ref":"Gremlex.Graph.html#other_v/1"},{"type":"function","title":"Gremlex.Graph.out/1","doc":"","ref":"Gremlex.Graph.html#out/1"},{"type":"function","title":"Gremlex.Graph.out/2","doc":"","ref":"Gremlex.Graph.html#out/2"},{"type":"function","title":"Gremlex.Graph.out_e/1","doc":"","ref":"Gremlex.Graph.html#out_e/1"},{"type":"function","title":"Gremlex.Graph.out_e/2","doc":"","ref":"Gremlex.Graph.html#out_e/2"},{"type":"function","title":"Gremlex.Graph.out_v/1","doc":"","ref":"Gremlex.Graph.html#out_v/1"},{"type":"function","title":"Gremlex.Graph.out_v/2","doc":"","ref":"Gremlex.Graph.html#out_v/2"},{"type":"function","title":"Gremlex.Graph.path/1","doc":"","ref":"Gremlex.Graph.html#path/1"},{"type":"function","title":"Gremlex.Graph.project/2","doc":"","ref":"Gremlex.Graph.html#project/2"},{"type":"function","title":"Gremlex.Graph.properties/1","doc":"","ref":"Gremlex.Graph.html#properties/1"},{"type":"function","title":"Gremlex.Graph.properties/2","doc":"Appends properties command to the traversal.\nReturns a graph to allow chaining.","ref":"Gremlex.Graph.html#properties/2"},{"type":"function","title":"Gremlex.Graph.property/2","doc":"","ref":"Gremlex.Graph.html#property/2"},{"type":"function","title":"Gremlex.Graph.property/3","doc":"Appends property command to the traversal.\nReturns a graph to allow chaining.","ref":"Gremlex.Graph.html#property/3"},{"type":"function","title":"Gremlex.Graph.property/4","doc":"","ref":"Gremlex.Graph.html#property/4"},{"type":"function","title":"Gremlex.Graph.range/3","doc":"","ref":"Gremlex.Graph.html#range/3"},{"type":"function","title":"Gremlex.Graph.range/4","doc":"","ref":"Gremlex.Graph.html#range/4"},{"type":"function","title":"Gremlex.Graph.repeat/2","doc":"","ref":"Gremlex.Graph.html#repeat/2"},{"type":"function","title":"Gremlex.Graph.select/2","doc":"","ref":"Gremlex.Graph.html#select/2"},{"type":"function","title":"Gremlex.Graph.side_effect/2","doc":"Appends `sideEffect` command to the traversal.\n\nThe side effect is a way to store the result of a traversal in a key\nthat can be used later in the traversal. It is similar to a variable\nthat can be used to store intermediate results.\n\nExample:\n```\ng.V()\n  .hasLabel('Product')\n  .has('price', gt(100))\n  .sideEffect(__.property('discounted', true))\n```","ref":"Gremlex.Graph.html#side_effect/2"},{"type":"function","title":"Gremlex.Graph.simple_path/1","doc":"","ref":"Gremlex.Graph.html#simple_path/1"},{"type":"function","title":"Gremlex.Graph.store/2","doc":"Appends the store command to the traversal. Takes in a graph and the name of\nthe side effect key that will hold the aggregate.\nReturns a graph to allow chaining.","ref":"Gremlex.Graph.html#store/2"},{"type":"function","title":"Gremlex.Graph.sum/1","doc":"","ref":"Gremlex.Graph.html#sum/1"},{"type":"opaque","title":"Gremlex.Graph.t/0","doc":"","ref":"Gremlex.Graph.html#t:t/0"},{"type":"function","title":"Gremlex.Graph.tail/1","doc":"","ref":"Gremlex.Graph.html#tail/1"},{"type":"function","title":"Gremlex.Graph.tail/2","doc":"","ref":"Gremlex.Graph.html#tail/2"},{"type":"function","title":"Gremlex.Graph.times/2","doc":"","ref":"Gremlex.Graph.html#times/2"},{"type":"function","title":"Gremlex.Graph.to/2","doc":"","ref":"Gremlex.Graph.html#to/2"},{"type":"function","title":"Gremlex.Graph.to_bulk_set/1","doc":"","ref":"Gremlex.Graph.html#to_bulk_set/1"},{"type":"function","title":"Gremlex.Graph.to_list/1","doc":"","ref":"Gremlex.Graph.html#to_list/1"},{"type":"function","title":"Gremlex.Graph.to_set/1","doc":"","ref":"Gremlex.Graph.html#to_set/1"},{"type":"function","title":"Gremlex.Graph.try_next/1","doc":"","ref":"Gremlex.Graph.html#try_next/1"},{"type":"function","title":"Gremlex.Graph.unfold/1","doc":"","ref":"Gremlex.Graph.html#unfold/1"},{"type":"function","title":"Gremlex.Graph.unfold/2","doc":"","ref":"Gremlex.Graph.html#unfold/2"},{"type":"function","title":"Gremlex.Graph.union/2","doc":"","ref":"Gremlex.Graph.html#union/2"},{"type":"function","title":"Gremlex.Graph.until/2","doc":"","ref":"Gremlex.Graph.html#until/2"},{"type":"function","title":"Gremlex.Graph.v/1","doc":"Appends values the `V` command allowing you to select a vertex.\nReturns a graph to allow chaining.","ref":"Gremlex.Graph.html#v/1"},{"type":"function","title":"Gremlex.Graph.v/2","doc":"Appends values the `V` command allowing you to select a vertex.\nReturns a graph to allow chaining.","ref":"Gremlex.Graph.html#v/2"},{"type":"function","title":"Gremlex.Graph.value_map/1","doc":"Appends valueMap command to the traversal.\nReturns a graph to allow chaining.","ref":"Gremlex.Graph.html#value_map/1"},{"type":"function","title":"Gremlex.Graph.value_map/2","doc":"","ref":"Gremlex.Graph.html#value_map/2"},{"type":"function","title":"Gremlex.Graph.values/2","doc":"Appends values command to the traversal.\nReturns a graph to allow chaining.","ref":"Gremlex.Graph.html#values/2"},{"type":"function","title":"Gremlex.Graph.where/2","doc":"","ref":"Gremlex.Graph.html#where/2"},{"type":"function","title":"Gremlex.Graph.within/1","doc":"Creates a `within` predicate that will match at least one of the values provided.\nTakes in a range or a list as the values.\nExamples:\n```\ng.V().has('age', within(1..18))\ng.V().has('name', within([\"some\", \"value\"]))\n```","ref":"Gremlex.Graph.html#within/1"},{"type":"function","title":"Gremlex.Graph.without/1","doc":"Creates a `without` predicate that will filter out values that match the values provided.\nTakes in a range or a list as the values.\nExamples:\n```\ng.V().has('age', without(18..30))\ng.V().has('name', without([\"any\", \"value\"]))\n```","ref":"Gremlex.Graph.html#without/1"},{"type":"module","title":"Gremlex.Path","doc":"","ref":"Gremlex.Path.html"},{"type":"function","title":"Gremlex.Path.from_response/1","doc":"","ref":"Gremlex.Path.html#from_response/1"},{"type":"type","title":"Gremlex.Path.t/0","doc":"","ref":"Gremlex.Path.html#t:t/0"},{"type":"module","title":"Gremlex.Request","doc":"","ref":"Gremlex.Request.html"},{"type":"function","title":"Gremlex.Request.new/1","doc":"Accepts plain query or a graph and returns a Request.","ref":"Gremlex.Request.html#new/1"},{"type":"type","title":"Gremlex.Request.t/0","doc":"","ref":"Gremlex.Request.html#t:t/0"},{"type":"module","title":"Gremlex.Request.Id","doc":"UUID generation vendored from `Ecto.UUID`","ref":"Gremlex.Request.Id.html"},{"type":"function","title":"Gremlex.Request.Id.generate/0","doc":"Generates a unique request id","ref":"Gremlex.Request.Id.html#generate/0"},{"type":"module","title":"Gremlex.Vertex","doc":"","ref":"Gremlex.Vertex.html"},{"type":"function","title":"Gremlex.Vertex.add_properties/2","doc":"","ref":"Gremlex.Vertex.html#add_properties/2"},{"type":"function","title":"Gremlex.Vertex.from_response/1","doc":"","ref":"Gremlex.Vertex.html#from_response/1"},{"type":"type","title":"Gremlex.Vertex.t/0","doc":"","ref":"Gremlex.Vertex.html#t:t/0"},{"type":"module","title":"Gremlex.VertexProperty","doc":"","ref":"Gremlex.VertexProperty.html"},{"type":"function","title":"Gremlex.VertexProperty.from_response/1","doc":"","ref":"Gremlex.VertexProperty.html#from_response/1"},{"type":"type","title":"Gremlex.VertexProperty.t/0","doc":"","ref":"Gremlex.VertexProperty.html#t:t/0"},{"type":"extras","title":"README","doc":"[![CI](https://github.com/coingaming/gremlex/actions/workflows/ci.yaml/badge.svg)](https://github.com/coingaming/gremlex/actions/workflows/ci.yaml)\n[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)\n\n# Gremlex\n\nAn Elixir client for Apache TinkerPop™ aka [Gremlin](http://tinkerpop.apache.org/gremlin.html).\n\nGremlex does not support all functions (yet). It is pretty early on in it's development. But you can always use raw Gremlin queries by using `Client.query(\" \")`","ref":"readme.html"},{"type":"extras","title":"Installation - README","doc":"Install from Hex.pm:\n\n```elixir\ndef deps do\n  [\n    {:gremlex, \"~> 0.4.4\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Examples - README","doc":"","ref":"readme.html#examples"},{"type":"extras","title":"Basic Usage - README","doc":"The two main modules that you'll want to use are `Gremlex.Graph` and `Gremlex.Client`.\n\n`Gremlex.Graph` is the module that hosts all the functions needed to build a Gremlin query.\nThe DSL is a simple set of functions that carries over a graph for every step. Once you've\ndefined your query, you can simply call `Gremlex.Client.query/1` to perform it.\n\n```elixir\niex(1)> alias Gremlex.Graph\nGremlex.Graph\niex(2)> alias Gremlex.Client\nGremlex.Client\niex(3)> Graph.g() |> Graph.v() |> Client.query\n{:ok,\n [\n   %Gremlex.Vertex{\n     id: 1,\n     label: \"person\",\n     properties: %{age: [29], name: [\"marko\"]}\n   }\n ]}\n```","ref":"readme.html#basic-usage"},{"type":"extras","title":"Gremlin Query to Gremlex - README","doc":"This gremlin query:\n```\ng.V().has(\"name\",\"marko\")\n  .out(\"knows\")\n  .out(\"knows\")\n  .values(\"name\")\n```\nWould translate in Gremlex to:\n```elixir\nGraph.g()\n|> Graph.v()\n|> Graph.has(\"name\", \"marko\")\n|> Graph.out(\"knows\")\n|> Graph.out(\"knows\")\n|> Graph.values(\"name\")\n|> Client.query\n```\n\n#### Raw Queries\n```elixir\nClient.query(\"\"\"\n  g.V().match(\n    __.as(\"a\").out(\"knows\").as(\"b\"),\n    __.as(\"a\").out(\"created\").as(\"c\"),\n    __.as(\"b\").out(\"created\").as(\"c\"),\n    __.as(\"c\").in(\"created\").count().is(2)\n  )\n  .select(\"c\").by(\"name\")\n\"\"\")\n```","ref":"readme.html#gremlin-query-to-gremlex"},{"type":"extras","title":"Configuration - README","doc":"You can configure Gremlex by adding the following to your `config.exs`:\n\n```elixir\nconfig :gremlex,\n  host: \"127.0.0.1\",\n  port: 8182,\n  path: \"/gremlin\",\n  pool_size: 10,\n  max_overflow: 10,\n  secure: false,\n  ping_delay: 60_000,\n  opts: []\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Parameters - README","doc":"* `host`: Gremlin host to connect to (defaults to \"127.0.0.1\")\n* `port`: Port Gremlin is listening to on host (defaults to 8182)\n* `path`: Websocket path to Gremlin (defaults to \"/gremlin\")\n* `pool_size`: The number of connections to keep open in the pool (defaults to 10)\n* `secure`: Set to `true` to connect to a server with SSL enabled\n* `ping_delay`: Delay in milliseconds to send a pong frame to the server. If 0, then a pong frame won't be scheduled. (defaults to 0)\n* `opts`: A keyword list of options for customizing the webSocket connection, such as timeouts, SSL settings, or proxy configurations. This corresponds to the same option in [Mint.WebSocket options](https://hexdocs.pm/mint_web_socket/Mint.WebSocket.html#new/5-options)","ref":"readme.html#parameters"},{"type":"extras","title":"Contributing - README","doc":"$ git clone https://github.com/coingaming/gremlex.git\n    $ cd gremlex\n    $ ./scripts/test.sh","ref":"readme.html#contributing"},{"type":"extras","title":"CHANGELOG","doc":"","ref":"changelog.html"},{"type":"extras","title":"0.4.4 [2025-06-12] - CHANGELOG","doc":"","ref":"changelog.html#0-4-4-2025-06-12"},{"type":"extras","title":"Added - CHANGELOG","doc":"- function `Gremlex.Graph.neq/2` similar to `Gremlex.Graph.eq/2`","ref":"changelog.html#added"},{"type":"extras","title":"0.4.3 [2025-06-05] - CHANGELOG","doc":"","ref":"changelog.html#0-4-3-2025-06-05"},{"type":"extras","title":"Fixes - CHANGELOG","doc":"- Increase default timeout from 5s to 30s to match Gremlin's default `evaluationTimeout`","ref":"changelog.html#fixes"},{"type":"extras","title":"0.4.2 [2025-05-19] - CHANGELOG","doc":"","ref":"changelog.html#0-4-2-2025-05-19"},{"type":"extras","title":"Added - CHANGELOG","doc":"- function `Gremlex.Graph.gte/2` similar to `Gremlex.Graph.gt/2`","ref":"changelog.html#added"},{"type":"extras","title":"0.4.1 [2025-04-16] - CHANGELOG","doc":"","ref":"changelog.html#0-4-1-2025-04-16"},{"type":"extras","title":"Fixes - CHANGELOG","doc":"- `@spec` in `Gremlex.Graph.by/2` and `Gremlex.Graph.by/3`","ref":"changelog.html#fixes"},{"type":"extras","title":"0.4.0 - CHANGELOG","doc":"","ref":"changelog.html#0-4-0"},{"type":"extras","title":"Added - CHANGELOG","doc":"- `Gremlex.Graph.side_effect/2`\n- `Gremlex.Graph.emit/1`\n- Multiple edge ids in `Gremlex.Graph.e/2`","ref":"changelog.html#added"},{"type":"extras","title":"Breaking changes - CHANGELOG","doc":"- Replaced websocket library with `Mint.Websocket`\n- Removed `confex` style configuration","ref":"changelog.html#breaking-changes"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.1"}}